with Ada.Text_IO; use Ada.Text_IO;
with Ada.Numerics.Elementary_Functions;
use  Ada.Numerics.Elementary_Functions;
-- Find primes suitable of WH generator
procedure Find is
   No_Primes: constant := 50;
   Start: constant Integer := Integer'Last;
   Primes: array( Integer range 1..No_Primes) of Integer;
   Next_Pos: Integer := 1;
   Next, Factor: Integer;

   package My_IO is new Integer_IO(Integer);
   use My_IO;

   function Divisor(N: Integer) return Integer is
      Top: constant Integer := Integer(sqrt(Float(N)));
      Temp: Integer := 2;
      begin
      while Temp <= Top loop
         if N/Temp*Temp = N then
            return Temp;
         elsif Temp = 2 then
            Temp := Temp + 1;
         else
            Temp := Temp + 2;
         end if;
      end loop;
      return 1;
      end Divisor;
 
begin
if Integer'Size /= 32 then
   Put("Integer type not 32 bits");
else
   -- find possible primes
   Next := Start;
   while Next_Pos <= No_Primes loop
      Factor := Divisor(Next);
      if Factor = 1 then
         Primes(Next_Pos) := Next;
         Next_Pos := Next_Pos + 1;
         Put(Next);
         Put(" is prime");
         New_Line;
      end if;
      Next := Next - 2;
   end loop;
   -- find factors of p-1
   for P in Integer range 1..No_Primes loop
      Next := Primes(P) - 1;
      Put(Primes(P));
      Put(" - 1 = ");
      Factor := Divisor(Next);
      while Factor /= 1 loop
         Put(Factor, Width => 1);
         Next := Next / Factor;
         if Factor /= 1 then
            Put(" * ");
            Factor := Divisor(Next);
         end if;
      end loop;
      Put(Next, Width => 1);
      New_Line;
   end loop;
end if;
end Find;
 