#include "unif01.h"
 
double Version4a (void);
double Version6a (void);

/* Richard Simard's email of 22nd Feb 2005 lists:
ucrypto_CreateISAAC
ucrypto_CreateAES
ugfsr_CreateMT19937_02
ulec_CreateMRG63k3a
ulec_CreateMRG32k3a
ulec_CreateCLCG4  */


unif01_Gen * uknuth_CreateRan_array2 (long s, long A[100]); /* Page 60 */ 
unif01_Gen * ugfsr_CreateMT19937_02 (unsigned long seed, unsigned long Key[], int len); /* page 41 */
unif01_Gen * ulec_CreateCLCG4 (long S1, long S2, long S3, long S4); /* page 49 */
unif01_Gen * ulec_CreateMRG32k3a (double x10, double x11, double x12, double x20, double x21, double x22); /* page 50 */
unif01_Gen * ulec_CreateMRG63k3a (longlong s10, longlong s11, longlong s12, longlong s20, longlong s21, longlong s22); /* page 51 */
unif01_Gen * ucrypto_CreateISAAC (int flag, unsigned int A[256]); /* page 73 */
unif01_Gen * ucrypto_CreateAES (unsigned char *Key, int KeyLen, unsigned char *Seed); /* page 73 */

void ucrypto_DeleteAES (unif01_Gen * gen); 
void ucrypto_DeleteISAAC (unif01_Gen * gen); 
int main (void) 
{ 
   unif01_Gen *gen;
   long A[100];
   unsigned long Key[10];
   unsigned int AA[256];
   unsigned char AESKey[16], Seed[16];
   AESKey[0]  = 1; AESKey[1]  = 6; AESKey[2]  = 8; AESKey[3]  = 100;
   AESKey[4]  = 1; AESKey[5]  = 6; AESKey[6]  = 8; AESKey[7]  = 100;
   AESKey[8]  = 1; AESKey[9]  = 6; AESKey[10] = 8; AESKey[11] = 100;
   AESKey[12] = 1; AESKey[13] = 6; AESKey[14] = 8; AESKey[15] = 100;
   Seed[0]  = 1; Seed[1]  = 6; Seed[2]  = 8; Seed[3]  = 100;
   Seed[4]  = 1; Seed[5]  = 6; Seed[6]  = 8; Seed[7]  = 100;
   Seed[8]  = 1; Seed[9]  = 6; Seed[10] = 8; Seed[11] = 100;
   Seed[12] = 1; Seed[13] = 6; Seed[14] = 8; Seed[15] = 100;
   
   
   gen = unif01_CreateExternGen01 ("Version4a", Version4a);
   unif01_TimerSumGenWr (gen, 30000000, TRUE);
   unif01_DeleteExternGen01 (gen); 

   gen = unif01_CreateExternGen01 ("Version6a", Version6a);
   unif01_TimerSumGenWr (gen, 30000000, TRUE);
   unif01_DeleteExternGen01 (gen); 

   gen = uknuth_CreateRan_array2 (2, A);
   unif01_TimerSumGenWr (gen, 30000000, TRUE);
   uknuth_DeleteRan_array2 (gen); 
   
   gen = ugfsr_CreateMT19937_02 (2, Key, 0);
   unif01_TimerSumGenWr (gen, 30000000, TRUE);
   ugfsr_DeleteGen (gen); 
   
   gen = ulec_CreateMRG32k3a (123., 123., 123., 123., 123., 123.);
   unif01_TimerSumGenWr (gen, 10000000, TRUE);
   ulec_DeleteGen (gen); 

   gen = ulec_CreateMRG63k3a (12345, 45123, 12378, 12390, 123000, 123789);
   unif01_TimerSumGenWr (gen, 10000000, TRUE);
   ulec_DeleteGen (gen); 

   gen = ucrypto_CreateISAAC (0, AA);
   unif01_TimerSumGenWr (gen, 10000000, TRUE);
   ucrypto_DeleteISAAC (gen); 

   gen = ucrypto_CreateAES (AESKey, 128, Seed);
   unif01_TimerSumGenWr (gen, 10000000, TRUE);
   ucrypto_DeleteAES (gen); 

   gen = ulec_CreateCLCG4(1234, 5678, 9876, 54321);
   unif01_TimerSumGenWr (gen, 30000000, TRUE);
   ulec_DeleteGen (gen); 
   
   return 0; 

}



