package Version4 is

 type Generator is private;
 subtype Uniformly_Distributed is Long_Float range 0.0 .. 1.0;

 procedure Random (Gen: in out Generator; Value: out Uniformly_Distributed);
   -- Value gives the next random number, Gen is advanced

 procedure Reset (Gen       : out Generator;
                  Initiator : in Positive);
   -- uses Initiator to reset Gen

 procedure Reset(Gen       : out Generator);
   -- uses the clock to reset Gen


 Image_Width : constant := 33;
 subtype String_State is String(1..Image_Width);
  -- The character encoding of the state

 function Image (Gen   : in Generator) return String_State;
   -- Gives the character encoding of the generator.

 function Value (Coded_State: String_State) return Generator;
   -- Gives the value of the Generator corresponding to the string

 function Next_Sequence(Gen   : in Generator) return Generator;
   -- Produces a new starting value for a generator for which a sequence
   -- of starting values produces a random sequence.

private
  type Generator is record
                    ix, iy, iz: Integer := 1;
                    end record;

end Version4;


