#include "version6.h"
#include <time.h>
#include <stdio.h>

double Random(Generator *Gen)
 {
    double W;
    Gen->ix = 11600L * (Gen->ix % 185127L) - 10379L* (Gen->ix/185127L);
    Gen->iy = 47003L * (Gen->iy %  45688L) - 10479L* (Gen->iy/ 45688L);
    Gen->iz = 23000L * (Gen->iz %  93368L) - 19423L* (Gen->iz/ 93368L);
    Gen->it = 33000L * (Gen->it %  65075L) -  8123L* (Gen->it/ 65075L);
    if (Gen->ix < 0)
       Gen->ix += 2147483579L;
    if (Gen->iy < 0)
       Gen->iy += 2147483543L;
    if (Gen->iz < 0)
       Gen->iz += 2147483423L;
    if (Gen->it < 0)
       Gen->it += 2147483123L;
    W =  (double)(Gen->ix)*0.0000000004656613022697297188506231646486
       + (double)(Gen->iy)*0.0000000004656613100759859932486569933169
       + (double)(Gen->iz)*0.0000000004656613360968421314794009471615
       + (double)(Gen->it)*0.0000000004656614011489951998100056779817;
    while (W >= 1.0)
       W -= 1.0;
    return W;
 }
 

void Reset1( Generator *Gen)
 {
    float Temp = (float) clock();
    time_t current;
    struct tm current_tm;
    current = time(&current);
    current_tm = *gmtime(&current);
    Gen->ix = current_tm.tm_mon;
    Gen->iy = current_tm.tm_yday;
    Gen->iz = current_tm.tm_hour;
    while (Temp > 2147000000.0F)
       Temp -= 2147000000.0F;
    Gen->it = (long int) Temp;
 }
 
static long long int Exp(long long int Mult, long long int  Power, long long int Prime)
 {
     long long int Temp;
     long long int MP;
     long long int So_Far;
     Temp = Power;
     MP = Mult;
     So_Far = 1;
     while (Temp > 0)
        {
	    if (Temp % 2 == 1)
	       So_Far = (So_Far*MP) % Prime;
	    MP = (MP*MP) % Prime;
	    Temp = Temp/2;
        }
     return So_Far;
 }

void Reset2( Generator *Gen, long int Initiator )
 {
    Gen->ix = (long int) (9876543L*Exp(46340, (long long int)(Initiator), 2147483579LL) % 2147483579LL);
    Gen->iy = (long int) (4789321L*Exp(22000, (long long int)(Initiator), 2147483543LL) % 2147483543LL);
    Gen->iz = 1345678901L;
    Gen->it = 1901678345L;
 }


void Image( Generator *Gen, char *Coded_State)
 {
 /* For C99 should do:
  * snprintf(Coded_State, Image_Width, "% ld% ld% ld% ld", Gen->ix,  Gen->iy,  Gen->iz, Gen->it);
  */
 sprintf(Coded_State, "% ld% ld% ld% ld", Gen->ix,  Gen->iy,  Gen->iz, Gen->it);
 }


void Value( char *Coded_State, Generator *Gen)
 {
 sscanf(Coded_State, "%ld%ld%ld%ld", &Gen->ix,  &Gen->iy,  &Gen->iz,  &Gen->it); 
 }

void Next_Sequence( Generator *Gen1, Generator *Gen2)
 {
   long int  ix, iy;
   ix = 46340 * (Gen1->ix % 46341) - 41639 * (Gen1->ix / 46341);
   iy = 22000 * (Gen1->iy % 97612) - 19543 * (Gen1->iy / 97612);
   if (ix < 0)
      ix += 2147483579L;
   if (iy < 0)
      iy += 2147483543L;
   Gen2->ix = ix;
   Gen2->iy = iy;
   Gen2->iz = Gen1->iz;
   Gen2->it = Gen1->it;
 }
 

     
	       
     
